//Dejiko is here, Nyo!

//Credits to 
//Delf, CreeperFace941, BuggieTheBug, Kirb and PRBlaster (Coders) and Rueven (Helping me figuring out how to handle voice clips)
freeslot (
"sfx_dgcjv1",
"sfx_dgcjv2",
"sfx_dgcjv3",
"sfx_dgcjv4",
"sfx_dgcow1",
"sfx_dgcow2",
"sfx_dgcow3",
"sfx_dgcow4",
"sfx_dgcat1",
"sfx_dgcat2",
"sfx_dgcat3",
"sfx_dgcat4",
"sfx_dgcdi1",
"sfx_dgcdi2",
"sfx_dgcdi3",
"sfx_dgcdi4",
"sfx_dgcdie",
"sfx_dgcdsh",
"sfx_dgccln",
"sfx_dgcdie",
"sfx_dgcbv1",
"sfx_dgcbv2",
"sfx_dgcbv3",
"sfx_dgceyb",
"sfx_dgcdrn",
"sfx_dgcch1",
"sfx_dgcch2",
"sfx_dgcch3",
"S_PLAY_EYEA",
"S_PLAY_EYEB",
"S_MEKEBALL",
"MT_MEKERABEAM",
"SPR2_EYBM",
"SPR2_EYBC",
"sfx_dgcscr"
)

states[S_PLAY_EYEA] = {
		sprite = SPR_PLAY,
		frame = SPR2_EYBC,
		tics = 2,
		nextstate = S_PLAY_EYEB
}

states[S_PLAY_EYEB] = {
		sprite = SPR_PLAY,
		frame = SPR2_EYBM,
		tics = 12,
		nextstate = S_PLAY_FALL
}

states[S_MEKEBALL] = {
		sprite = SPR_NULL,
        tics = -1,
		nextstate = S_MEKEBALL,
		action = nil,
		var1 = 0,
		var2 = 0
}

mobjinfo[MT_MEKERABEAM] = {
	doomednum = -1,
	spawnstate = S_MEKEBALL,
	radius = 5*FRACUNIT,
	deathstate = S_NULL,
	deathsound = sfx_bebomb,
	height = 5*FRACUNIT,
	painchance = 150*FRACUNIT,
	speed = 75*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	mass = 100,
	flags = MF_NOGRAVITY|MF_FLOAT|MF_MISSILE,

}

//Sound Effects
local DejikoJump
local DejikoHurt
local DejikoAttack
local DejikoDeath
local DejikoDrown
local DejikoEyebeam
local DejikoVoiceJump = {sfx_dgcjv1, sfx_dgcjv2, sfx_dgcjv3, sfx_dgcjv4} 
local DejikoVoiceHurt = {sfx_dgcow1, sfx_dgcow2, sfx_dgcow3, sfx_dgcow4} 
local DejikoVoiceAttack = {sfx_dgcat1, sfx_dgcat2, sfx_dgcat3, sfx_dgcat4} 
local DejikoVoiceDeath = {sfx_dgcdi1, sfx_dgcdi2, sfx_dgcdi3, sfx_dgcdi4} 
local DejikoVoiceEyebeam = {sfx_dgcbv1, sfx_dgcbv2, sfx_dgcbv3, sfx_none, sfx_none, sfx_none, sfx_none, sfx_none, sfx_none} 
//local DejikoVoiceSpin = {sfx_sgsp1, sfx_sgsp2, sfx_sgsp3}
//local DejikoVoiceSpindash = {sfx_sgsp1, sfx_sgsp2, sfx_sgsp3}

addHook("MobjLineCollide", function(mo, line)
	if mo and mo.valid and line and line.valid and mo.player and mo.player.valid
	and mo.skin == "dejiko"
		mo.player.clastlinehit = line
	end
end)

addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid
		if mo.type == MT_PLAYER and mo.player
		and mo.skin == "dejiko"
			if mo.player.clastlinehit
				if (mo.player.pflags & PF_JUMPED or mo.player.freefall)
				and not mo.player.cantWall
				//and not (mo.player.clastlinehit.flags & ML_NOCLIMB)
					mo.player.wallJumped = 0
					local angle = R_PointToAngle2(0, 0, mo.player.clastlinehit.dx, mo.player.clastlinehit.dy)
					mo.player.wallLastAng = angle
					if P_PointOnLineSide(mo.x, mo.y, mo.player.clastlinehit) == 0
						mo.player.wallAng = angle+ANGLE_90+ANGLE_180
						if mo.player.clastlinehit.frontside
							local side = mo.player.clastlinehit.frontside
							local invside = mo.player.clastlinehit.backside
							if invside and invside.sector and mo.z >= invside.sector.ceilingheight
								if not side.toptexture
									mo.player.cantClimb = true
								end
							end
							if invside and invside.sector and mo.z < invside.sector.ceilingheight
								if not side.bottomtexture
									mo.player.cantClimb = true
								end
							end
							if not side.toptexture
							and not side.midtexture
							and not side.bottomtexture
								mo.player.cantClimb = true
							end
						end
					else
						mo.player.wallAng = angle-ANGLE_90+ANGLE_180
						if mo.player.clastlinehit.backside
							local side = mo.player.clastlinehit.backside
							local invside = mo.player.clastlinehit.frontside
							if invside and invside.sector and mo.z >= invside.sector.ceilingheight
								if not side.toptexture
									mo.player.cantClimb = true
								end
							end	
							if invside and invside.sector and mo.z < invside.sector.ceilingheight
								if not side.bottomtexture
									mo.player.cantClimb = true
								end
							end
							if not side.toptexture
							and not side.midtexture
							and not side.bottomtexture
								mo.player.cantClimb = true
							end
						end	
					end
					if mo.momz*P_MobjFlip(mo) <= FRACUNIT
					and not mo.player.cantClimb
						mo.player.wallCling = 5
						mo.state = S_PLAY_CLING
						local dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_DUST)
						dust.fuse = 15
						P_Thrust(dust, angle, P_RandomRange(-5, 5)*FRACUNIT)
						local player = mo.player
						if (player.cmd.sidemove or player.cmd.forwardmove)
						and player.ctrlAng
							P_Thrust(player.mo, player.ctrlAng, FRACUNIT)
						end
						if P_PointOnLineSide(mo.x, mo.y, mo.player.clastlinehit) == 0
							mo.player.drawangle = angle+ANGLE_90+ANGLE_180
							P_Thrust(mo, angle+ANGLE_90, FRACUNIT*2)
							P_Thrust(dust, angle+ANGLE_90, FRACUNIT*2)
						else
							mo.player.drawangle = angle-ANGLE_90+ANGLE_180
							P_Thrust(mo, angle-ANGLE_90, FRACUNIT*2)
							P_Thrust(dust, angle-ANGLE_90, FRACUNIT*2)
						end
						if mo.momz*P_MobjFlip(mo) <= -5*FRACUNIT
							P_SetObjectMomZ(mo, -5*FRACUNIT)
						end
					end
				end	
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "dejiko"
		player.ctrlAng = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
		if player.wallCling 
			player.wallCling = $ - 1
				if player.cmd.buttons & BT_JUMP
				if not player.wall
				or (player.wall and player.wall <= 5)
				and player.wallAng
				and not player.cantClimb
				and not player.cantWall
					player.mo.state = S_PLAY_JUMP
					player.pflags = $|PF_JUMPED
					player.cantWall = 5
					player.drawangle = player.wallAng
					P_Thrust(player.mo, player.wallAng, 24*FRACUNIT)
					P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
					player.freefall = false
					S_StartSound(mo, sfx_dgccln)
				end
			end
			if player.pflags & PF_THOKKED
				player.pflags = $ & ~PF_THOKKED
			end
		else
			if player.cantClimb
				player.cantClimb = false
			end
		end
		if player.cantWall
			player.cantWall = $ - 1
		end
		if P_IsObjectOnGround(player.mo)
			player.freefall = false
		else		
			if not (player.pflags & PF_JUMPED)
				player.freefall = true
			end
		end
		player.wall = $ or 0
		if player.cmd.buttons & BT_JUMP
			player.wall = $ + 1
		else
			player.wall = 0
		end
		player.clastlinehit = nil
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo.skin == "dejiko"
		if not (player.pflags & PF_THOKKED)
			player.charability = CA_NONE
	        player.pflags = $1 & ~PF_JUMPED
			P_SetObjectMomZ(player.mo, 0*FRACUNIT)
			P_Thrust(player.mo, player.mo.angle, 20*FRACUNIT)
			S_StartSound(player.mo, sfx_dgcdsh)
			player.mo.state = S_PLAY_GLIDE
			player.pflags = $1|PF_THOKKED|PF_SPINNING
		end
	end
end)

//LASER-EYE BEAMS!
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "dejiko"
			if not (player.mo.firedown)
				player.mo.firedown = 0
			end
			if (player.cmd.buttons & BT_CUSTOM1)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE) //no shooting when NiGHTS Super Sonic!
			and not (player.powers[pw_carry] == CR_ROPEHANG) //rope hangs use spin for letting go
			and not (player.powers[pw_carry] == CR_MACESPIN) //control chains use spin for shifting angle I think?
			and not (player.pflags & PF_GAMETYPEOVER) //no shooting when tagged
			and not (player.pflags & PF_STASIS) //no shooting when in stasis in tag mode either
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) //no shooting when following a zoomtube
			and not (player.pflags & PF_SPINNING) //no shooting when ...spinning?
			and player.mo.firedown == 0
			and not (player.weapondelay)
				player.mo.firedown = 1
				player.mo.state = S_PLAY_EYEA
				player.weapondelay = 25
				local an = player.mo.angle
				local slope = player.aiming
				S_StartSound(player.mo, sfx_dgceyb)
				P_SpawnPlayerMissile(player.mo, MT_MEKERABEAM, MF2_RAILRING|MF2_EXPLOSION)
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
				player.mo.firedown = 0
			end
			if player.weapondelay > 10
				player.drawangle = player.mo.angle
			end
			if player.mo.state == S_PLAY_EYEB
						player.mo.momz = 0
						player.mo.momx = 0
						player.mo.momy = 0
			if player.mo.state == S_PLAY_EYEB
						player.mo.momz = 0
						player.mo.momx = 0
						player.mo.momy = 0
				end
			end
		end
	end
end
)

addHook("MobjThinker", function(beam)
	if beam.laserthink == nil
		beam.laserthink = false
	end
	if beam.laserrange == nil
		beam.laserrange = 0
	end
	if beam.valid
		local thoktrail = P_SpawnMobjFromMobj(beam, 0, 0, 0, MT_THOK)
		thoktrail.color = SKINCOLOR_YELLOW
		thoktrail.fuse = 20
		thoktrail.blendmode = AST_ADD
		beam.laserrange = $ + 1
	end
	if beam.laserrange == 20
		P_KillMobj(beam,beam,beam)
	end
end, MT_MEKERABEAM)

//Voice Stuff 

DejikoJump = function(player)
	if player.mo.skin == "dejiko"
    local soundnum = P_RandomRange(1, #DejikoVoiceJump)
    S_StartSound(player.mo, DejikoVoiceJump[soundnum])
	end
end

DejikoHurt = function(player)
	if player.mo.skin == "dejiko"
	local soundnum = P_RandomRange(1, #DejikoVoiceHurt)
    S_StartSound(player.mo, DejikoVoiceHurt[soundnum])
	end
end

DejikoAttack = function(player)
	if player.mo.skin == "dejiko"
	local soundnum = P_RandomRange(1, #DejikoVoiceAttack)
    S_StartSound(player.mo, DejikoVoiceAttack[soundnum])
	end
end

DejikoDeath = function(player)
	if player.mo.skin == "dejiko"
	local soundnum = P_RandomRange(1, #DejikoVoiceDeath)
    S_StartSound(player.mo, DejikoVoiceDeath[soundnum])
	S_StartSound(player.mo, sfx_dgcdie)
	end
end

DejikoDrown = function(player)
	if player.mo.skin == "dejiko"
	S_StartSound(player.mo, sfx_dgcdrn)
	S_StartSound(player.mo, sfx_dgcdie)
	end
end

DejikoEyebeam = function(player)
	if player.mo.skin == "dejiko"
	local soundnum = P_RandomRange(1, #DejikoVoiceEyebeam)
    S_StartSound(player.mo, DejikoVoiceEyebeam[soundnum])
	end
end

local function DejikoVoiceHandler(player)
//SHE SPEAKS
	if player.jumpvoice ~= true
        if (player.mo.state == S_PLAY_JUMP)
            DejikoJump(player)
        player.jumpvoice = true
		end
	end
    if P_IsObjectOnGround(player.mo)    
		player.jumpvoice = false
	end
end

local function DejikoPainVoice(player)	
if player.hurtvoice ~= true
	if P_PlayerInPain(player) == true
			DejikoHurt(player)
		player.hurtvoice = true
		end
	end
	if P_PlayerInPain(player) ~= true
		player.hurtvoice = false
	end
end

local function DejikoAttackVoice(player)	
if player.attackvoice ~= true
	if (player.mo.state == S_PLAY_GLIDE)
			        DejikoAttack(player)
			player.attackvoice = true
		end
	end
	if not (player.mo.state == S_PLAY_GLIDE)
		player.attackvoice = false
	end
end

local function DejikoEyebeamVoice(player)	
if player.eyebeamvoice ~= true
	if (player.mo.state == S_PLAY_EYEB)
			        DejikoEyebeam(player)
			player.eyebeamvoice = true
		end
	end
	if not (player.mo.state == S_PLAY_EYEB)
		player.eyebeamvoice = false
	end
end

local function DejikoDeathVoice(player)	
if player.deathvoice ~= true
	if (player.mo.state == S_PLAY_DEAD)
			        DejikoDeath(player)
			player.deathvoice = true
		end
	end
	if not (player.mo.state == S_PLAY_DEAD)
		player.deathvoice = false
	end
end

local function DejikoDrownVoice(player)	
if player.drownvoice ~= true
	if (player.mo.state == S_PLAY_DRWN)
			        DejikoDrown(player)
			player.drownvoice = true
		end
	end
	if not (player.mo.state == S_PLAY_DRWN)
		player.drownvoice = false
	end
end

addHook("PlayerThink", function(player) 
    if (P_IsObjectOnGround(player.mo)) 
    and player.mo.skin == "dejiko"
    and (player.mo.state == S_PLAY_RUN) 
    and not player.powers[pw_super]
        P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
    end

        DejikoVoiceHandler(player)
		DejikoPainVoice(player)
		DejikoAttackVoice(player)
		DejikoDeathVoice(player)
		DejikoEyebeamVoice(player)
		DejikoDrownVoice(player)
end)

addHook("PlayerSpawn", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == "dejiko"
		player.freefall = false
		player.wallCling = 0
		player.wallgrabsfx = 0
		player.cantWall = 0
		player.cantClimb = false
		player.wallJumped = 0
		player.jumpvoice = false
		player.hurtvoice = false
		player.attackvoice = false
		player.deathvoice = false
		player.drownvoice = false
		player.eyebeamvoice = false
		
	end
end)